//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "App_SplitDialog.h"
#include "Moa_Files.h"
#include "Moa_Forms.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAppSplitDialog* AppSplitDialog = NULL;
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::Button1Click(TObject* ASender)
{
	AnsiString LDirectory = Input1;
	if(!SelectDirectory("Choose the directory.", WideString(), LDirectory)) {
		Abort();
	}
	SetCurrentDir(LDirectory);
	Input1 = LDirectory;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::ComboBox1Exit(TObject* ASender)
{
	Input5;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::Edit1Exit(TObject* ASender)
{
	Input1;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::Edit2Exit(TObject* ASender)
{
	Input2;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::FormCloseQuery(TObject* ASender, bool& ACanClose)
{
	if(ModalResult == mrOk) {
		Values = Inputs;
	}
	ActiveControl = NULL;
	ACanClose = true;
}
//---------------------------------------------------------------------------
TSplitArguments __fastcall TAppSplitDialog::GetInputs()
{
	TSplitArguments LInputs;
	LInputs.Directory = Input1;
	LInputs.Archive = Input2;
	LInputs.EntryPrefix = Input3;
	LInputs.EntrySuffix = Input4;
	LInputs.Extension = Input5;
	return LInputs;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::SetInputs(const TSplitArguments& AInputs)
{
	Input1 = AInputs.Directory;
	Input2 = AInputs.Archive;
	Input3 = AInputs.EntryPrefix;
	Input4 = AInputs.EntrySuffix;
	Input5 = AInputs.Extension;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppSplitDialog::GetInput1()
{
	AnsiString LInput = Edit1->Text;
	if(!TPathUtilities::IsAbsolute(LInput)) {
		throw EInvalidFormInput("Type a path in absolute form.", Edit1);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::SetInput1(const AnsiString& AInput1)
{
	Edit1->Text = AInput1;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppSplitDialog::GetInput2()
{
	AnsiString LInput = Edit2->Text;
	if(LInput.Length() == 0) {
		throw EInvalidFormInput("Type the archive name.", Edit2);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::SetInput2(const AnsiString& AInput2)
{
	Edit2->Text = AInput2;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppSplitDialog::GetInput3()
{
	return Edit3->Text;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::SetInput3(const AnsiString& AInput3)
{
	Edit3->Text = AInput3;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppSplitDialog::GetInput4()
{
	return Edit4->Text;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::SetInput4(const AnsiString& AInput4)
{
	Edit4->Text = AInput4;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TAppSplitDialog::GetInput5()
{
	AnsiString LInput = ComboBox1->Text;
	if(TPathUtilities::StartsWithCharacter(LInput, '.')) {
		throw EInvalidFormInput("Remove separators.", ComboBox1);
	}
	return LInput;
}
//---------------------------------------------------------------------------
void __fastcall TAppSplitDialog::SetInput5(const AnsiString& AInput5)
{
	ComboBox1->Text = AInput5;
}
//---------------------------------------------------------------------------
__fastcall TAppSplitDialog::TAppSplitDialog(TComponent* AOwner) :
	TForm(AOwner),
	FValues(GetDefaultValues())
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TAppSplitDialog::~TAppSplitDialog()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TAppSplitDialog* __fastcall TAppSplitDialog::EnsureCreate()
{
	if(AppSplitDialog == NULL) {
		AppSplitDialog = new TAppSplitDialog(Application);
	}
	return AppSplitDialog;
}
//---------------------------------------------------------------------------
TSplitArguments __fastcall TAppSplitDialog::GetDefaultValues()
{
	TSplitArguments LValues;
	LValues.Directory = GetCurrentDir();
	LValues.Archive = AnsiString();
	LValues.EntryPrefix = "#";
	LValues.EntrySuffix = AnsiString();
	LValues.Extension = "d88";
	return LValues;
}
//---------------------------------------------------------------------------
bool __fastcall TAppSplitDialog::Execute()
{
	Inputs = Values;
	SelectFirst();
	return ShowModal() == mrOk;
}
//---------------------------------------------------------------------------

