//---------------------------------------------------------------------------
#ifndef Moa_ListViewsH
#define Moa_ListViewsH
//---------------------------------------------------------------------------
#include "Moa_Lists.h"
namespace Comctrls { class TListView; } using namespace Comctrls;
//---------------------------------------------------------------------------
// Version: 2.2.0
// Date: 2012-07-12 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
namespace Moa_listviews {
//---------------------------------------------------------------------------
class TListViewItemUtilities
{
private:
protected:
public:
	static void __fastcall EnsureVisible(TListView* AListView, int AIndex, bool AAllowPartial);
	static UINT __fastcall GetState(TListView* AListView, int AIndex);
	static void __fastcall SetState(TListView* AListView, int AIndex, UINT AState);
	static bool __fastcall IsCut(TListView* AListView, int AIndex);
	static void __fastcall SetCut(TListView* AListView, int AIndex, bool ACut);
	static bool __fastcall IsDropHilighted(TListView* AListView, int AIndex);
	static void __fastcall SetDropHilighted(TListView* AListView, int AIndex, bool ADropHilighted);
	static bool __fastcall IsFocused(TListView* AListView, int AIndex);
	static void __fastcall SetFocused(TListView* AListView, int AIndex, bool AFocused);
	static bool __fastcall IsSelected(TListView* AListView, int AIndex);
	static void __fastcall SetSelected(TListView* AListView, int AIndex, bool ASelected);
};
//---------------------------------------------------------------------------
class TListViewItemsUtilities
{
private:
	static TIntegerDynArray __fastcall AddItemsInRealMode(TListView* AListView, int ACount);
	static TIntegerDynArray __fastcall AddItemsInVirtualMode(TListView* AListView, int ACount);
	static void __fastcall InsertItemsInRealMode(TListView* AListView, const TIntegerDynArray& AIndexes);
	static void __fastcall InsertItemsInVirtualMode(TListView* AListView, const TIntegerDynArray& AIndexes);
	static void __fastcall DeleteItemsInRealMode(TListView* AListView, const TIntegerDynArray& AIndexes);
	static void __fastcall DeleteItemsInVirtualMode(TListView* AListView, const TIntegerDynArray& AIndexes);
	static void __fastcall ClearInRealMode(TListView* AListView);
	static void __fastcall ClearInVirtualMode(TListView* AListView);
	static void __fastcall ExchangeInRealMode(TListView* AListView, int AIndex1, int AIndex2);
	static void __fastcall ExchangeInVirtualMode(TListView* AListView, int AIndex1, int AIndex2);
	static void __fastcall MoveInRealMode(TListView* AListView, int ASourceIndex, int ADestinationIndex);
	static void __fastcall MoveInVirtualMode(TListView* AListView, int ASourceIndex, int ADestinationIndex);
	static void __fastcall ReorderInRealMode(TListView* AListView, const TListReorderRecords& ARecords);
	static void __fastcall ReorderInVirtualMode(TListView* AListView, const TListReorderRecords& ARecords);
	static TIntegerDynArray __fastcall MakeIndexes(int AInitialIndex, int ACount);
protected:
public:
	static int __fastcall Add(TListView* AListView);
	static TIntegerDynArray __fastcall AddItems(TListView* AListView, int ACount);
	static void __fastcall Insert(TListView* AListView, int AIndex);
	static void __fastcall InsertItems(TListView* AListView, const TIntegerDynArray& AIndexes);
	static TIntegerDynArray __fastcall InsertSucceedingItems(TListView* AListView, int AIndex, int ACount);
	static void __fastcall Delete(TListView* AListView, int AIndex);
	static void __fastcall DeleteItems(TListView* AListView, const TIntegerDynArray& AIndexes);
	static void __fastcall DeleteSucceedingItems(TListView* AListView, int AIndex, int ACount);
	static void __fastcall Clear(TListView* AListView);
	static void __fastcall Exchange(TListView* AListView, int AIndex1, int AIndex2);
	static void __fastcall ExchangeItems(TListView* AListView, const TListExchangeRecords& ARecords);
	static void __fastcall Move(TListView* AListView, int ASourceIndex, int ADestinationIndex);
	static void __fastcall Reorder(TListView* AListView, const TListReorderRecords& ARecords);
	static void __fastcall SelectAll(TListView* AListView);
	static void __fastcall ReverseSelection(TListView* AListView);
	static void __fastcall ClearSelection(TListView* AListView);
	static int __fastcall GetSelectionIndex(TListView* AListView);
	static TIntegerDynArray __fastcall GetSelectionIndexes(TListView* AListView);
	static void __fastcall SetSelectionIndexes(TListView* AListView, const TIntegerDynArray& AIndexes);
	static int __fastcall GetSelectionCount(TListView* AListView);
	static int __fastcall GetFocusIndex(TListView* AListView);
	static void __fastcall SetFocusIndex(TListView* AListView, int AIndex);
	static int __fastcall GetFocusCount(TListView* AListView);
	static int __fastcall FindByState(TListView* AListView, UINT AState);
	static TIntegerDynArray __fastcall FindItemsByState(TListView* AListView, UINT AState);
	static int __fastcall CountByState(TListView* AListView, UINT AState);
	static void __fastcall InvalidateItems(TListView* AListView, const TIntegerDynArray& AIndexes);

	// Obsoleted
	static void __fastcall InvalidateItems(TListView* AListView, int AStartIndex, int AEndIndex);
	static void __fastcall RepaintItems(TListView* AListView, int AStartIndex, int AEndIndex);

	static int __fastcall AssureValidIndex(TListView* AListView, int AIndex);
};
//---------------------------------------------------------------------------
} // End namespace Moa_listviews
using namespace Moa_listviews;
//---------------------------------------------------------------------------
#endif

