//---------------------------------------------------------------------------
#ifndef Moa_ShellLibraryH
#define Moa_ShellLibraryH
//---------------------------------------------------------------------------
// Version: 1.0.0
// Date: 2012-04-08 UTC+09:00
// Author: Moochos
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
namespace Moa_shelllibrary {
//---------------------------------------------------------------------------
class EShellLibraryError : public Exception
{
public:
	__fastcall EShellLibraryError(const AnsiString& AMessage) : Exception(AMessage) {}
};
//---------------------------------------------------------------------------
class EFileDropError : public EShellLibraryError
{
public:
	__fastcall EFileDropError(const AnsiString& AMessage) : EShellLibraryError(AMessage) {}
};
//---------------------------------------------------------------------------
class TDroppedFiles : public TObject
{
private:
	HDROP FHandle;
	void __fastcall AssureUnfinished();
	AnsiString __fastcall GetFile(int AIndex);
	int __fastcall GetCount();
	TPoint __fastcall GetPoint();
protected:
public:
	__fastcall TDroppedFiles(const TMessage& AMessage);
	virtual __fastcall ~TDroppedFiles();
	virtual void __fastcall Finish();
	virtual bool __fastcall IsFinished();
	__property HDROP Handle = {read=FHandle};
	__property AnsiString Files[int AIndex] = {read=GetFile};
	__property int Count = {read=GetCount};
	__property TPoint Point = {read=GetPoint};
};
//---------------------------------------------------------------------------
typedef void __fastcall (__closure * TFileDropEvent)(TObject* ASender, TDroppedFiles* AFiles, bool& AHandled);
//---------------------------------------------------------------------------
class TFileDropWatcher : public TObject
{
private:
	TWinControl* FControl;
	TWndMethod FNextHandleMessage;
	TFileDropEvent FOnFileDrop;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall HandleMessage(TMessage& AMessage);
	bool __fastcall WMDropFiles(TMessage& AMessage);
	bool __fastcall GetEnabled();
	void __fastcall SetEnabled(bool AEnabled);
	__property TWndMethod NextHandleMessage = {read=FNextHandleMessage};
protected:
	virtual bool __fastcall DoFileDrop(TDroppedFiles* AFiles);
public:
	__fastcall TFileDropWatcher(TWinControl* AControl);
	virtual __fastcall ~TFileDropWatcher();
	__property TWinControl* Control = {read=FControl};
	__property bool Enabled = {read=GetEnabled, write=SetEnabled};
	__property TFileDropEvent OnFileDrop = {read=FOnFileDrop, write=FOnFileDrop};
};
//---------------------------------------------------------------------------
} // End namespace Moa_shelllibrary
using namespace Moa_shelllibrary;
//---------------------------------------------------------------------------
#endif

